
package kayles;

import calc.Constraint;
import calc.Optimizer;
import java.util.ArrayList;
import utils.Range;

/**
 *
 * @author sjoerd
 */
public class Main {
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new Main().start();
    }
    
    public void start(){
        ///* Case1
        Configuration c1 = new Configuration("case 1");
        c1.addNode(1,NodeType.WHITE, 0, Range.INF, 0, 0);
        c1.addNode(2,NodeType.WHITE, 0, Range.INF, 0, Range.INF);
        c1.addNode(3,NodeType.WHITE, 0, Range.INF, 0, Range.INF);
        c1.addNode(4,NodeType.WHITE, 0, Range.INF, 0, Range.INF);
        c1.connect(1, 2);
        c1.connect(1, 3);
        c1.connect(1, 4);
        //*/
        
        ///* Case 2
        Configuration c2 = new Configuration("case 2");
        c2.addNode(1,NodeType.WHITE, 0, Range.INF, 0, 2);
        c2.addNode(2,NodeType.WHITE, 0, Range.INF, 0, 0);
        c2.addNode(3,NodeType.WHITE, 0, Range.INF, 0, 2);
        c2.addNode(4,NodeType.RED,   0, Range.INF, 0, Range.INF);
        c2.connect(1, 2);
        c2.connect(2, 3);
        c2.connect(2, 4);
        // */
        ///* Case 3.2
        Configuration c32 = new Configuration("case 3.2");
        c32.addNode(1,NodeType.WHITE, 0, Range.INF, 0, 0);
        c32.addNode(2,NodeType.WHITE, 0, Range.INF, 0, 0);
        c32.addNode(3,NodeType.WHITE, 0, Range.INF, 0, 0);
        c32.addNode(4,NodeType.RED,   0, Range.INF, 0, Range.INF);
        c32.addNode(5,NodeType.RED,   0, Range.INF, 0, Range.INF);
        c32.connect(1, 2);
        c32.connect(2, 3);
        c32.connect(1, 4);
        c32.connect(3, 5);
        //*/
        ///* Case 3.3
        Configuration c33 = new Configuration("case 3.3");
        c33.addNode(1,NodeType.WHITE, 0, Range.INF, 0, 0);
        c33.addNode(2,NodeType.WHITE, 0, Range.INF, 0, 0);
        c33.addNode(3,NodeType.WHITE, 0, Range.INF, 0, 0);
        c33.addNode(4,NodeType.RED,   0, Range.INF, 0, Range.INF);
        c33.connect(1, 2);
        c33.connect(2, 3);
        c33.connect(1, 4);
        c33.connect(3, 4);
        // */
        ///* Case 3.4
        Configuration c34 = new Configuration("case 3.4");
        c34.addNode(1,NodeType.WHITE, 0, Range.INF, 0, 0);
        c34.addNode(2,NodeType.WHITE, 0, Range.INF, 0, 0);
        c34.addNode(3,NodeType.WHITE, 0, Range.INF, 0, 0);
        c34.addNode(4,NodeType.WHITE, 0, Range.INF, 0, 0);
        c34.addNode(5,NodeType.RED,   0, Range.INF, 0, Range.INF);
        c34.addNode(6,NodeType.RED,   0, Range.INF, 0, Range.INF);
        c34.connect(1, 2);
        c34.connect(2, 3);
        c34.connect(3, 4);
        c34.connect(1, 5);
        c34.connect(4, 6);
        // */
        ///* Case 3.4
        Configuration c35 = new Configuration("case 3.5");
        c35.addNode(1,NodeType.WHITE, 0, 0, 0, 0);
        c35.addNode(2,NodeType.WHITE, 0, Range.INF, 0, 0);
        c35.addNode(3,NodeType.WHITE, 0, Range.INF, 0, 0);
        c35.addNode(4,NodeType.WHITE, 0, 0, 0, 0);
        c35.addNode(5,NodeType.RED,   0, Range.INF, 0, Range.INF);
        c35.connect(1, 2);
        c35.connect(2, 3);
        c35.connect(3, 4);
        c35.connect(1, 5);
        c35.connect(4, 5);
        // */
        ///* Case 4.1.?
        Configuration c41 = new Configuration("case 4.1.3");
        c41.addNode(1,NodeType.WHITE, 0, Range.INF, 0, 0);
        c41.addNode(2,NodeType.WHITE, 0, Range.INF, 0, 0);
        c41.addNode(3,NodeType.WHITE, 0, 0, 0, 0);
        c41.addNode(4,NodeType.RED,   0, Range.INF, 0, Range.INF);
        c41.connect(1, 2);
        c41.connect(2, 3);
        c41.connect(4, 1);
        // */
        ///* Case 4.2 (& 4.3)
        Configuration c42 = new Configuration("case 4.2");
        c42.addNode(1,NodeType.WHITE, 0, Range.INF, 0, 0);
        c42.addNode(2,NodeType.WHITE, 0, 0, 0, 0);
        c42.addNode(3,NodeType.RED,   0, Range.INF, 0, 0);
        c42.connect(1, 2);
        c42.connect(1, 3);
        // */
        ///* Case 5
        Configuration c5 = new Configuration("case 5");
        c5.addNode(1,NodeType.WHITE, 0, Range.INF, 0, 0);
        c5.addNode(2,NodeType.RED, 0, Range.INF, 0, Range.INF);
        c5.addNode(3,NodeType.RED, 0, Range.INF, 0, Range.INF);
        c5.connect(1, 2);
        c5.connect(1, 3);
        // */
        ///* Case 6
        Configuration c6 = new Configuration("case 6");
        c6.addNode(1, NodeType.WHITE, 0, 0, 0, 0);
        c6.addNode(2, NodeType.RED, 0, Range.INF, 0, Range.INF);
        c6.connect(1, 2);
        //*/
        
        // expandabiliy is no longer used, but indicates which case to expand if we have a choice
        // /* Virtual Master Case
        c1.expandability = 5;
        c2.expandability = 5;
        c33.expandability = 2;
        c34.expandability = 2;
        c35.expandability = 2;
        c41.expandability = 2;
        c42.expandability = 2;
        c5.expandability = 4;
        c6.expandability = 1;
        
        
        /* build a virtual master case */ 
        Configuration vmc = new Configuration("Master Case");
        ArrayList<Configuration> children = vmc.getChildren();
        children.add(c1);
        children.add(c2);
        children.add(c32);
        children.add(c33);
        children.add(c34);
        children.add(c35);
       // children.add(c41); // is added as external constraints
        children.add(c42); // covers 4.3 from the paper as well
        children.add(c5);
        //children.add(c6);  // covers both 6.1 and 6.2 // also as external
        
        // */
        
        //win.addConfiguration(c);
        Optimizer.staticInstance.allconfigs.add(vmc);
        Optimizer.staticInstance.allconfigs.addAll(children);
        Optimizer.staticInstance.root = vmc;
        MainWindow win = new MainWindow(vmc);
        
        // the other cases are added as external constraints
        Optimizer o = Optimizer.staticInstance;
      //  o.addConstraint(o.getCase1());
        //o.addConstraint(o.getCase2()); 
        o.addxternalConstraint(o.getCase31());
    //    o.addConstraint(o.getCase32());
   //     o.addConstraint(o.getCase33());
    //    o.addConstraint(o.getCase34());
   //     o.addConstraint(o.getCase35());
        o.addxternalConstraint(o.getCase36());
        o.addxternalConstraint(o.getCase41());
        //o.addConstraint(o.getCase42());
        //o.addConstraint(o.getCase43());
     //   o.addConstraint(o.getCase5());
        o.addxternalConstraint(o.getCase61());
        o.addxternalConstraint(o.getCase62());
        
        /*the new constraints from the improved algo by Hans */
        Constraint new1 = new Constraint(); // 6+3a,3+a,2,2
        new1.addTerm(6, 3);
        new1.addTerm(3, 1);
        new1.addTerm(2, 0);
        new1.addTerm(2, 0);
        Constraint new2 = new Constraint(); // 3+2a,1-a
        new2.addTerm(3, 2);
        new2.addTerm(1, -1);
        o.addxternalConstraint(new1);
        o.addxternalConstraint(new2);
        
    }
}
