/*
 * MainWindow.java
 *
 * Created on Sep 8, 2011, 10:32:12 AM
 */
package kayles;

import calc.Constraint;
import calc.Optimizer;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JTree;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeSelectionModel;
import utils.Pair;

/**
 *
 * @author sjoerd
 */
public class MainWindow extends javax.swing.JFrame implements TreeSelectionListener {
    BufferedImage img;
    /** Creates new form MainWindow */
    private Configuration c;
    
    ArrayList<JGraph> graphs;
    
    DefaultTreeModel treemodel;
   // private DefaultMutableTreeNode rootNode;
    
    public MainWindow(Configuration c) {
        super("Kayles");
        initComponents();
        
        graphs = new ArrayList<JGraph>();
        //rootNode = new DefaultMutableTreeNode("Root Node");
        treemodel = new DefaultTreeModel(c);
        jTree1.setModel(treemodel);
        jTree1.addTreeSelectionListener(this);
        jTree1.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
        jTree1.setShowsRootHandles(true);
        jTree1.setCellRenderer(new DefaultTreeCellRenderer(){
            private Icon tight = new ImageIcon(getClass().getResource("/resources/tight.png"));
            private Icon ok = new ImageIcon(getClass().getResource("/resources/ok.png"));
            private Icon unknown = new ImageIcon(getClass().getResource("/resources/unknown.png"));
       //     private Icon expand = new ImageIcon(getClass().getResource("/resources/expand.png"));
      //      private Icon collapse = new ImageIcon(getClass().getResource("/resources/collapse.png"));
            private Icon folder_tight = new ImageIcon(getClass().getResource("/resources/folder-tight.png"));
            private Icon folder_ok = new ImageIcon(getClass().getResource("/resources/folder-ok.png"));
            private Icon isomorph = new ImageIcon(getClass().getResource("/resources/expand.png"));
            @Override
            public Component getTreeCellRendererComponent(
                        JTree tree,
                        Object value,
                        boolean sel,
                        boolean expanded,
                        boolean leaf,
                        int row,
                        boolean hasFocus) {
                super.getTreeCellRendererComponent( tree, value, sel, expanded, leaf, row, hasFocus);
                Configuration c = (Configuration)value;
                if(c.isLeaf()){
                    //Constraint con = c.getConstraint();
                    if(c.iso!=null){
                        setIcon(isomorph);
                    }else if(Optimizer.staticInstance.evaluatedConfigs.contains(c)){
                        if (Optimizer.staticInstance.tightConfigs.contains(c)) {
                            setIcon(tight);
                        } else {
                            setIcon(ok);
                        } 
                    }else{
                        setIcon(unknown);
                    }
                }else{
                    if(c.hasTightChildren()){
                        setIcon(folder_tight);
                    }else{
                        setIcon(folder_ok);
                    }
                }
                return this;
            }
        });
        
        //jTree1.setEditable(true);
        
        spinnerNode.setModel(new SpinnerNumberModel(0, 0, 100, 1));
        
        c.setTree(jTree1);
        setLocationByPlatform(true);
        pack();
        setVisible(true);

    }
    
    
    @Override
    public void paint(Graphics g2){
        super.paint(g2);
        

    }
    

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        fileChooser = new javax.swing.JFileChooser();
        jSplitPane2 = new javax.swing.JSplitPane();
        jSplitPane1 = new javax.swing.JSplitPane();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jPanel1 = new javax.swing.JPanel();
        buttonExpandWhite = new javax.swing.JButton();
        spinnerNode = new javax.swing.JSpinner();
        buttonRunEvaluation = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        buttonIsoCheck = new javax.swing.JButton();
        buttonExpandRed = new javax.swing.JButton();
        buttonCleverExpand = new javax.swing.JButton();
        buttonResolveSelected = new javax.swing.JButton();
        jLabel6 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jToggleButton1 = new javax.swing.JToggleButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        miSave = new javax.swing.JMenuItem();
        miOpen = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JPopupMenu.Separator();
        jMenuItem1 = new javax.swing.JMenuItem();
        menuHelp = new javax.swing.JMenu();
        miHelp = new javax.swing.JMenuItem();
        miAbout = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jSplitPane2.setDividerLocation(300);
        jSplitPane2.setResizeWeight(0.2);

        jSplitPane1.setDividerLocation(200);
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane1.setResizeWeight(1.0);

        jScrollPane4.setViewportView(jTree1);

        jSplitPane1.setTopComponent(jScrollPane4);

        jPanel1.setMinimumSize(new java.awt.Dimension(0, 300));
        jPanel1.setPreferredSize(new java.awt.Dimension(397, 300));

        buttonExpandWhite.setText("white neighborhood");
        buttonExpandWhite.setEnabled(false);
        buttonExpandWhite.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonExpandWhiteActionPerformed(evt);
            }
        });

        spinnerNode.setModel(new javax.swing.SpinnerNumberModel(Integer.valueOf(4), Integer.valueOf(1), null, Integer.valueOf(1)));
        spinnerNode.setValue(4);

        buttonRunEvaluation.setText("run evaluation");
        buttonRunEvaluation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonRunEvaluationActionPerformed(evt);
            }
        });

        jLabel2.setText("alpha:");

        jLabel3.setText("x:");

        jLabel4.setText("undefined");

        jLabel5.setText("undefined");

        jLabel7.setText("expand neighborhood of node:");

        buttonIsoCheck.setText("Isomorphism check");
        buttonIsoCheck.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonIsoCheckActionPerformed(evt);
            }
        });

        buttonExpandRed.setText("red neighborhood");
        buttonExpandRed.setEnabled(false);
        buttonExpandRed.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonExpandRedActionPerformed(evt);
            }
        });

        buttonCleverExpand.setText("single clever expand");
        buttonCleverExpand.setEnabled(false);
        buttonCleverExpand.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonCleverExpandActionPerformed(evt);
            }
        });

        buttonResolveSelected.setText("resolve selected case");
        buttonResolveSelected.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonResolveSelectedActionPerformed(evt);
            }
        });

        jLabel6.setText("jLabel6");

        jLabel9.setText("depth:");

        jLabel10.setText("jLabel10");

        jLabel11.setText("cases:");

        jToggleButton1.setText("print cases to stdout");
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel8)
                        .addGap(125, 125, 125))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel7)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(spinnerNode, javax.swing.GroupLayout.PREFERRED_SIZE, 45, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(buttonRunEvaluation)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(buttonResolveSelected))
                            .addComponent(buttonExpandWhite)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addGap(147, 147, 147)
                                        .addComponent(jLabel11))
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(jToggleButton1)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                            .addComponent(jLabel2)
                                            .addComponent(jLabel9)))
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(buttonIsoCheck)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(jLabel3)))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(jLabel5, javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel6, javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel4, javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel10, javax.swing.GroupLayout.Alignment.LEADING)))
                            .addComponent(buttonExpandRed)
                            .addComponent(buttonCleverExpand))
                        .addContainerGap(24, Short.MAX_VALUE))))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(buttonRunEvaluation)
                    .addComponent(buttonResolveSelected))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel7)
                    .addComponent(spinnerNode, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(6, 6, 6)
                .addComponent(buttonExpandWhite)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(buttonExpandRed)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(buttonCleverExpand)
                .addGap(1, 1, 1)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel11)
                            .addComponent(jLabel10))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel8)
                            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jLabel6)
                                .addComponent(jLabel9)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel4)
                            .addComponent(jLabel2)))
                    .addComponent(jToggleButton1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(buttonIsoCheck)
                    .addComponent(jLabel5)
                    .addComponent(jLabel3))
                .addGap(56, 56, 56))
        );

        jSplitPane1.setBottomComponent(jPanel1);

        jSplitPane2.setLeftComponent(jSplitPane1);
        jSplitPane2.setRightComponent(jTabbedPane1);

        jMenu1.setText("File");

        miSave.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_MASK));
        miSave.setText("Save");
        miSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miSaveActionPerformed(evt);
            }
        });
        jMenu1.add(miSave);

        miOpen.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.CTRL_MASK));
        miOpen.setText("Open");
        miOpen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miOpenActionPerformed(evt);
            }
        });
        jMenu1.add(miOpen);
        jMenu1.add(jSeparator1);

        jMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Q, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem1.setText("Quit");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem1);

        jMenuBar1.add(jMenu1);

        menuHelp.setText("Help");

        miHelp.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F1, 0));
        miHelp.setText("Explanation");
        menuHelp.add(miHelp);

        miAbout.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F2, 0));
        miAbout.setText("About");
        menuHelp.add(miAbout);

        jMenuBar1.add(menuHelp);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jSplitPane2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 682, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jSplitPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 495, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        System.exit(0);
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void buttonExpandWhiteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonExpandWhiteActionPerformed
        Configuration conf = (Configuration)jTree1.getSelectionPath().getLastPathComponent();
        Optimizer.staticInstance.allconfigs.addAll(conf.expandOnWhite((Integer)spinnerNode.getValue(), 2));
        Optimizer.staticInstance.allconfigs.remove(conf);
        Optimizer.staticInstance.run();
        jTree1.updateUI();
        //conf.multiColorExpand((Integer)jSpinner1.getValue());
    }//GEN-LAST:event_buttonExpandWhiteActionPerformed

    private void buttonRunEvaluationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonRunEvaluationActionPerformed
        Pair<Double> res = Optimizer.staticInstance.run();
        jLabel4.setText(""+res.t2);
        jLabel5.setText(""+res.t1);
        jTree1.updateUI();
        System.out.println("bound: "+res.t1+" for a="+res.t2);
    }//GEN-LAST:event_buttonRunEvaluationActionPerformed

    private void buttonIsoCheckActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonIsoCheckActionPerformed
        Optimizer.staticInstance.isoCheck();
        jTree1.updateUI();
    }//GEN-LAST:event_buttonIsoCheckActionPerformed

    private void buttonExpandRedActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonExpandRedActionPerformed
        Configuration conf = (Configuration)jTree1.getSelectionPath().getLastPathComponent();
        Optimizer.staticInstance.allconfigs.addAll(conf.expandOnRed((Integer)spinnerNode.getValue(), 1));
        Optimizer.staticInstance.allconfigs.remove(conf);
        Optimizer.staticInstance.run();
        jTree1.updateUI();
    }//GEN-LAST:event_buttonExpandRedActionPerformed

    private void buttonCleverExpandActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCleverExpandActionPerformed
        Configuration conf = (Configuration)jTree1.getSelectionPath().getLastPathComponent();
        conf.heuristicExpand();
        Optimizer.staticInstance.run();
        jTree1.updateUI();
    }//GEN-LAST:event_buttonCleverExpandActionPerformed

    private void miSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miSaveActionPerformed
        if(fileChooser.showSaveDialog(this)!=JFileChooser.APPROVE_OPTION)  return;
        try{
            FileOutputStream fos = new FileOutputStream(fileChooser.getSelectedFile());
            ObjectOutputStream oos = new ObjectOutputStream(fos);
            oos.writeObject(Optimizer.staticInstance);
            oos.close();
        }catch(Exception e){
            e.printStackTrace();
        }
        
        
    }//GEN-LAST:event_miSaveActionPerformed

    private void miOpenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miOpenActionPerformed
        if(fileChooser.showOpenDialog(this)!=JFileChooser.APPROVE_OPTION)  return;
        try{
            FileInputStream fis = new FileInputStream(fileChooser.getSelectedFile());
            ObjectInputStream ois = new ObjectInputStream(fis);
            Optimizer.staticInstance = (Optimizer)ois.readObject();
            ois.close();
            for(Configuration c: Optimizer.staticInstance.allconfigs){
                c.setTree(jTree1);
            }
            jTree1.setModel(new DefaultTreeModel(Optimizer.staticInstance.root));
            jTree1.updateUI();
        }catch(Exception e){
            e.printStackTrace();
        }
    }//GEN-LAST:event_miOpenActionPerformed

    private void buttonResolveSelectedActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonResolveSelectedActionPerformed
        Configuration mycase = (Configuration)jTree1.getSelectionPath().getLastPathComponent();
        int maxdepth = 1000;
        int d = 0;
        while(mycase.hasTightChildren() && d++<maxdepth){
            mycase.recursiveCleverExpand();
            Optimizer.staticInstance.isoCheck();
            Pair<Double> res = Optimizer.staticInstance.run();
            System.out.println("bound: "+res.t1+" for a="+res.t2);
        }
        Pair<Double> res = Optimizer.staticInstance.run();
        jLabel4.setText(""+res.t2);
        jLabel5.setText(""+res.t1);
        jTree1.updateUI();
    }//GEN-LAST:event_buttonResolveSelectedActionPerformed

    private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
        Configuration root = (Configuration)jTree1.getModel().getRoot();
        for(Constraint c:Optimizer.staticInstance.externalConstraints){
            System.out.println(c.mathematicaPrint());
        }
        root.printCases();
        
    }//GEN-LAST:event_jToggleButton1ActionPerformed

    /**
     * @param args the command line arguments
     */
    //public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */

        //</editor-fold>

        /* Create and display the form */
     //   java.awt.EventQueue.invokeLater(new Runnable() {

      //      public void run() {
      //          new MainWindow().setVisible(true);
      //      }
      //  });*/
    //}
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonCleverExpand;
    private javax.swing.JButton buttonExpandRed;
    private javax.swing.JButton buttonExpandWhite;
    private javax.swing.JButton buttonIsoCheck;
    private javax.swing.JButton buttonResolveSelected;
    private javax.swing.JButton buttonRunEvaluation;
    private javax.swing.JFileChooser fileChooser;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JPopupMenu.Separator jSeparator1;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JSplitPane jSplitPane2;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JTree jTree1;
    private javax.swing.JMenu menuHelp;
    private javax.swing.JMenuItem miAbout;
    private javax.swing.JMenuItem miHelp;
    private javax.swing.JMenuItem miOpen;
    private javax.swing.JMenuItem miSave;
    private javax.swing.JSpinner spinnerNode;
    // End of variables declaration//GEN-END:variables


    @Override
    public void valueChanged(TreeSelectionEvent e) {
        Configuration c = (Configuration)e.getPath().getLastPathComponent();
        
        jLabel6.setText(""+c.getDepth());
        jLabel10.setText(""+c.countDescendants());
        
        jTabbedPane1.removeAll();
        JGraph graph = new JGraph();
        System.out.print(graph.getSource(c, null));
        jTabbedPane1.add("base",graph);
        graph.render(c,null);
        graph.repaint();
        if(!Optimizer.staticInstance.evaluatedConfigs.contains(c)){
            return;
        }
        for(Reduction r:c.getBranchings()){
            graph = new JGraph();
            jTabbedPane1.add(r.toString(),graph);
            graph.render(c,r);
            graph.repaint();
        }
        //graph.render(c);
        //graph.repaint();
        //jTextArea1.setText(c.getConstraint().getVector());
        //jLabel7.setText(c.getConstraint().getVector());
    }


}
