package kayles;

import java.util.TreeMap;
import utils.Tuple;

/**
 * A reduction is a partial assignment of NodeTypes to a configuration
 * @author sjoerd
 */
public class Reduction extends TreeMap<Node,NodeType>{
    
    /**
     * calculate the gain (in term of alpha) for this reduction
     * @return 
     */
    public Tuple calcGain(){
        // basic result:
        Tuple res = new Tuple(0, 0);
        // set the current value to the total weight
        for(Node n:this.keySet()){
            // assign initial values
            if(n.type==NodeType.WHITE){
                res.num++;
            }else if(n.type==NodeType.RED){
                res.alpha++;
            }
        }

        // now subtract whatever remains
        for(Node n:this.keySet()){
            if(get(n)==NodeType.WHITE){
                res.num--;
            }else if(get(n)==NodeType.RED){
                res.alpha--;
            }
        }
        return res;
    }
    
    @Override
    public String toString(){
        return calcGain().toString();
    }
}
