package utils;

import java.io.Serializable;

/**
 * A Range has a maximum and a minimum
 * All methods are self-explanatory
 * @author sjoerd
 */
public class Range implements Serializable {
    public int lo,hi;
    public static final int INF = Integer.MAX_VALUE;
    
    public Range(){
        this(0,INF);
    }
    
    public Range(int lo, int hi){
        this.lo=lo;
        this.hi=hi;
    }
    
    public Range(Range r){
        this.lo=r.lo;
        this.hi=r.hi;
    }
    
    public boolean contains(int val) {
        return lo<=val && val<=hi;
    }
    
    public void add(int n){
        lo=Math.max(0,lo+n);
        if(n==INF || this.hi==INF){
            hi=INF;
        }else{
            hi=Math.max(0,hi+n); // at least 0
        }
    }
    
    public Range add(Range r){
        lo+=r.lo;
        if(this.hi==INF || r.hi==INF){
            hi=INF;
        }else{
            hi=this.hi+r.hi;
        }
        return this;
    }   
}
